﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GTA;
using GTA.Internal;

namespace PoliceMavericks
{
    public class PolMav : TickScript
    {
        public PolMav()
        {
            Interval = 250;
            Tick += new EventHandler(PolMav_Tick);
        }

        void PolMav_Tick(object sender, EventArgs e)
        {
            var mavericks = from vehicle in World.GetAllVehicles()
                            where (vehicle.IsDefined && vehicle.IsAlive && (vehicle.Model == CarID.PoliceMaverick || vehicle.Model == CarID.NewsMaverick) &&
                                   Function.Call<int>(0x046c, vehicle) == -1 && Function.Call(0x01f3, vehicle)) // 'get driver'/'in air'
                            select vehicle;

            foreach (var maverick in mavericks)
            {
                var modelID = PedID.csher;
                var town = Function.Call<int>(0x07ef, maverick.Position); // get town ID

                switch (town) {
                    case 0: // LA
                        modelID = PedID.lapd1;
                        break;
                    case 1: // SF
                        modelID = PedID.sfpd1;
                        break;
                    case 2: // vegas
                        modelID = PedID.lvpd1;
                        break;
                }

                Model.Load((int)modelID);
                var ped = Function.Call<Ped>(0x0129, maverick, 24, (int)modelID);
                // ped.NoLongerNeeded();

                ped = Function.Call<Ped>(0x01c8, maverick, 24, (int)modelID, 0);
                // ped.NoLongerNeeded();

                Model.Release((int)modelID);
            }
        }
    }
}
